# $Id: trans.tcl 747 2006-10-05 21:23:51Z sergei $
# Message translation

namespace eval ::trans {
    variable trans
    array set trans {}
}

proc ::trans::loadfile {filepath} {
    set fd [open $filepath "r"]
    fconfigure $fd -encoding utf-8
    uplevel #0 [read $fd]
    close $fd
}

proc ::trans::load {dirpath} {
    foreach filepath [glob -nocomplain -directory $dirpath *.msg] {
	loadfile $filepath
    }
}

proc ::trans::trset {lang msgfrom {msgto ""}} {
    variable trans

    if {$msgto != ""} {
	set trans($lang,$msgfrom) $msgto
    }
}

proc ::trans::trans {lang msg} {
    variable trans

    set langlist [split [string tolower $lang] -]
    set shortlang [lindex $langlist 0]
    set longlang [join $langlist _]

    if {[info exists trans($longlang,$msg)]} {
	return $trans($longlang,$msg)
    } elseif {[info exists trans($shortlang,$msg)]} {
	return $trans($shortlang,$msg)
    } else {
	return $msg
    }
}

